# pyright: reportUnusedImport=false
import struct
from typing import Optional, Self, Sequence
from .. import abcs
from ..core import Request, serialize_bytes_to
_bytes = bytes | bytearray | memoryview
def can_send_story(*, peer: abcs.InputPeer) -> Request[bool]:
    _buffer = bytearray(b'\xdd\xdf\xdf\xc7')
    peer._write_boxed_to(_buffer)
    return Request(b'' + _buffer)
def send_story(*, pinned: bool, noforwards: bool, peer: abcs.InputPeer, media: abcs.InputMedia, media_areas: Optional[Sequence[abcs.MediaArea]], caption: Optional[str], entities: Optional[Sequence[abcs.MessageEntity]], privacy_rules: Sequence[abcs.InputPrivacyRule], random_id: int, period: Optional[int]) -> Request[abcs.Updates]:
    _buffer = bytearray(b'D6\xb7\xbc')
    flags = (4 if pinned else 0) | (16 if noforwards else 0) | (0 if media_areas is None else 32) | (0 if caption is None else 1) | (0 if entities is None else 2) | (0 if period is None else 8)
    _buffer += struct.pack('<I', flags)
    peer._write_boxed_to(_buffer)
    media._write_boxed_to(_buffer)
    if media_areas is not None:
      _buffer += struct.pack('<ii', 0x1cb5c415, len(media_areas))
      for _t0 in media_areas:
        _t0._write_boxed_to(_buffer)
    if caption is not None:
      serialize_bytes_to(_buffer, caption.encode('utf-8'))
    if entities is not None:
      _buffer += struct.pack('<ii', 0x1cb5c415, len(entities))
      for _t1 in entities:
        _t1._write_boxed_to(_buffer)
    _buffer += struct.pack('<ii', 0x1cb5c415, len(privacy_rules))
    for _t2 in privacy_rules:
      _t2._write_boxed_to(_buffer)
    _buffer += struct.pack('<q', random_id)
    if period is not None:
      _buffer += struct.pack(f'<i', period)
    return Request(b'' + _buffer)
def edit_story(*, peer: abcs.InputPeer, id: int, media: Optional[abcs.InputMedia], media_areas: Optional[Sequence[abcs.MediaArea]], caption: Optional[str], entities: Optional[Sequence[abcs.MessageEntity]], privacy_rules: Optional[Sequence[abcs.InputPrivacyRule]]) -> Request[abcs.Updates]:
    _buffer = bytearray(b'F\xba\x83\xb5')
    flags = (0 if media is None else 1) | (0 if media_areas is None else 8) | (0 if caption is None else 2) | (0 if entities is None else 2) | (0 if privacy_rules is None else 4)
    _buffer += struct.pack('<I', flags)
    peer._write_boxed_to(_buffer)
    _buffer += struct.pack('<i', id)
    if media is not None:
      media._write_boxed_to(_buffer)
    if media_areas is not None:
      _buffer += struct.pack('<ii', 0x1cb5c415, len(media_areas))
      for _t0 in media_areas:
        _t0._write_boxed_to(_buffer)
    if caption is not None:
      serialize_bytes_to(_buffer, caption.encode('utf-8'))
    if entities is not None:
      _buffer += struct.pack('<ii', 0x1cb5c415, len(entities))
      for _t1 in entities:
        _t1._write_boxed_to(_buffer)
    if privacy_rules is not None:
      _buffer += struct.pack('<ii', 0x1cb5c415, len(privacy_rules))
      for _t2 in privacy_rules:
        _t2._write_boxed_to(_buffer)
    return Request(b'' + _buffer)
def delete_stories(*, peer: abcs.InputPeer, id: Sequence[int]) -> Request[Sequence[int]]:
    _buffer = bytearray(b'_\xdbY\xae')
    peer._write_boxed_to(_buffer)
    _buffer += struct.pack('<ii', 0x1cb5c415, len(id))
    _buffer += struct.pack(f'<{len(id)}i', *id)
    return Request(b'' + _buffer)
def toggle_pinned(*, peer: abcs.InputPeer, id: Sequence[int], pinned: bool) -> Request[Sequence[int]]:
    _buffer = bytearray(b'\xef\xa1u\x9a')
    peer._write_boxed_to(_buffer)
    _buffer += struct.pack('<ii', 0x1cb5c415, len(id))
    _buffer += struct.pack(f'<{len(id)}i', *id)
    _buffer += struct.pack('<I', pinned)
    return Request(b'' + _buffer)
def get_all_stories(*, next: bool, hidden: bool, state: Optional[str]) -> Request[abcs.stories.AllStories]:
    _buffer = bytearray(b'%\xd6\xb0\xee')
    flags = (2 if next else 0) | (4 if hidden else 0) | (0 if state is None else 1)
    _buffer += struct.pack('<I', flags)
    if state is not None:
      serialize_bytes_to(_buffer, state.encode('utf-8'))
    return Request(b'' + _buffer)
def get_pinned_stories(*, peer: abcs.InputPeer, offset_id: int, limit: int) -> Request[abcs.stories.Stories]:
    _buffer = bytearray(b'\xdc\xa5!X')
    peer._write_boxed_to(_buffer)
    _buffer += struct.pack('<ii', offset_id, limit)
    return Request(b'' + _buffer)
def get_stories_archive(*, peer: abcs.InputPeer, offset_id: int, limit: int) -> Request[abcs.stories.Stories]:
    _buffer = bytearray(b'\x16 5\xb4')
    peer._write_boxed_to(_buffer)
    _buffer += struct.pack('<ii', offset_id, limit)
    return Request(b'' + _buffer)
def get_stories_by_id(*, peer: abcs.InputPeer, id: Sequence[int]) -> Request[abcs.stories.Stories]:
    _buffer = bytearray(b't\xcatW')
    peer._write_boxed_to(_buffer)
    _buffer += struct.pack('<ii', 0x1cb5c415, len(id))
    _buffer += struct.pack(f'<{len(id)}i', *id)
    return Request(b'' + _buffer)
def toggle_all_stories_hidden(*, hidden: bool) -> Request[bool]:
    _buffer = bytearray(b'\xc4W%|')
    _buffer += struct.pack('<I', hidden)
    return Request(b'' + _buffer)
def read_stories(*, peer: abcs.InputPeer, max_id: int) -> Request[Sequence[int]]:
    _buffer = bytearray(b'\xc8\xdaV\xa5')
    peer._write_boxed_to(_buffer)
    _buffer += struct.pack('<i', max_id)
    return Request(b'' + _buffer)
def increment_story_views(*, peer: abcs.InputPeer, id: Sequence[int]) -> Request[bool]:
    _buffer = bytearray(b'\xfb\x8a\x02\xb2')
    peer._write_boxed_to(_buffer)
    _buffer += struct.pack('<ii', 0x1cb5c415, len(id))
    _buffer += struct.pack(f'<{len(id)}i', *id)
    return Request(b'' + _buffer)
def get_story_views_list(*, just_contacts: bool, reactions_first: bool, peer: abcs.InputPeer, q: Optional[str], id: int, offset: str, limit: int) -> Request[abcs.stories.StoryViewsList]:
    _buffer = bytearray(b'W<\xd2~')
    flags = (1 if just_contacts else 0) | (4 if reactions_first else 0) | (0 if q is None else 2)
    _buffer += struct.pack('<I', flags)
    peer._write_boxed_to(_buffer)
    if q is not None:
      serialize_bytes_to(_buffer, q.encode('utf-8'))
    _buffer += struct.pack('<i', id)
    serialize_bytes_to(_buffer, offset.encode('utf-8'))
    _buffer += struct.pack('<i', limit)
    return Request(b'' + _buffer)
def get_stories_views(*, peer: abcs.InputPeer, id: Sequence[int]) -> Request[abcs.stories.StoryViews]:
    _buffer = bytearray(b'\xc8l\xe1(')
    peer._write_boxed_to(_buffer)
    _buffer += struct.pack('<ii', 0x1cb5c415, len(id))
    _buffer += struct.pack(f'<{len(id)}i', *id)
    return Request(b'' + _buffer)
def export_story_link(*, peer: abcs.InputPeer, id: int) -> Request[abcs.ExportedStoryLink]:
    _buffer = bytearray(b' \xef\x8d{')
    peer._write_boxed_to(_buffer)
    _buffer += struct.pack('<i', id)
    return Request(b'' + _buffer)
def report(*, peer: abcs.InputPeer, id: Sequence[int], reason: abcs.ReportReason, message: str) -> Request[bool]:
    _buffer = bytearray(b'\x8c\xfa#\x19')
    peer._write_boxed_to(_buffer)
    _buffer += struct.pack('<ii', 0x1cb5c415, len(id))
    _buffer += struct.pack(f'<{len(id)}i', *id)
    reason._write_boxed_to(_buffer)
    serialize_bytes_to(_buffer, message.encode('utf-8'))
    return Request(b'' + _buffer)
def activate_stealth_mode(*, past: bool, future: bool) -> Request[abcs.Updates]:
    _buffer = bytearray(b'f\xd1\xbbW')
    flags = (1 if past else 0) | (2 if future else 0)
    _buffer += struct.pack('<I', flags)
    return Request(b'' + _buffer)
def send_reaction(*, add_to_recent: bool, peer: abcs.InputPeer, story_id: int, reaction: abcs.Reaction) -> Request[abcs.Updates]:
    _buffer = bytearray(b'\xb26\xd7\x7f')
    flags = (1 if add_to_recent else 0)
    _buffer += struct.pack('<I', flags)
    peer._write_boxed_to(_buffer)
    _buffer += struct.pack('<i', story_id)
    reaction._write_boxed_to(_buffer)
    return Request(b'' + _buffer)
def get_peer_stories(*, peer: abcs.InputPeer) -> Request[abcs.stories.PeerStories]:
    _buffer = bytearray(b'P\xdaJ,')
    peer._write_boxed_to(_buffer)
    return Request(b'' + _buffer)
def get_all_read_peer_stories() -> Request[abcs.Updates]:
    _buffer = bytearray(b'\xf9\xe7Z\x9b')
    return Request(b'' + _buffer)
def get_peer_max_ds(*, id: Sequence[abcs.InputPeer]) -> Request[Sequence[int]]:
    _buffer = bytearray(b'\xc3\x83YS')
    _buffer += struct.pack('<ii', 0x1cb5c415, len(id))
    for _t0 in id:
      _t0._write_boxed_to(_buffer)
    return Request(b'' + _buffer)
def get_chats_to_send() -> Request[abcs.messages.Chats]:
    _buffer = bytearray(b'`\x8bj\xa5')
    return Request(b'' + _buffer)
def toggle_peer_stories_hidden(*, peer: abcs.InputPeer, hidden: bool) -> Request[bool]:
    _buffer = bytearray(b'\xc4\x15\x04\xbd')
    peer._write_boxed_to(_buffer)
    _buffer += struct.pack('<I', hidden)
    return Request(b'' + _buffer)
def get_boosts_status(*, peer: abcs.InputPeer) -> Request[abcs.stories.BoostsStatus]:
    _buffer = bytearray(b'r\x94DL')
    peer._write_boxed_to(_buffer)
    return Request(b'' + _buffer)
def get_boosters_list(*, peer: abcs.InputPeer, offset: str, limit: int) -> Request[abcs.stories.BoostersList]:
    _buffer = bytearray(b'\x80\xf9~3')
    peer._write_boxed_to(_buffer)
    serialize_bytes_to(_buffer, offset.encode('utf-8'))
    _buffer += struct.pack('<i', limit)
    return Request(b'' + _buffer)
def can_apply_boost(*, peer: abcs.InputPeer) -> Request[abcs.stories.CanApplyBoostResult]:
    _buffer = bytearray(b'\xbd\xc1\x05\xdb')
    peer._write_boxed_to(_buffer)
    return Request(b'' + _buffer)
def apply_boost(*, peer: abcs.InputPeer) -> Request[bool]:
    _buffer = bytearray(b'+|\x9d\xf2')
    peer._write_boxed_to(_buffer)
    return Request(b'' + _buffer)
